<id>
Link IP for Hidden User and Last IP Mod for YaBB 2.1
</id>

<version>
1.2
</version>

<mod info>
Tested on and coded for YaBB 2.1

**Please read the "readme.txt" file for more extensive information.**

If you've installed the Hidden User and Last IP mods, run this mod to install Link IP.

If you're interested in knowing the details of the IP addresses of your users, this mod will turn your IP addresses in your Board Index, General Member List and Admin Member List from regular text into links that will connect with DNSstuff.com's IP utilities (Reverse DNS, Whois, Geolocation, Traceroute).

The following areas can have linked IP addresses:
- The main board index
- General and Admin member lists
- Users' profiles
- Error log
- Message display
- Users' profiles

Installation Instructions:

1) Remove previous version of this mod
2) Run this mod.
3) Upload your modified files to your server (note below) as well as the link_ip.lng (English only for now) and link_ip.pl (to Admin directory).
4) Check the Link IP configuration in the Admin Center to make sure the Link IP functions are enabled (BoardMod Mods->Last IP Mod)
5) Go into the Last IP configuration area in the Admin Center to select which IP utility you want to use.

Modifies the following files:
-AdminIndex.pl
-YaBB.pl
-Admin/Admin.pl
-Admin/AdminSubList.pl
-Admin/ErrorLog.pl
-Admin/ModList.pl
-Admin/ViewMembers.pl
-Sources/BoardIndex.pl
-Source/Display.pl
-Sources/Memberlist.pl
-Sources/Profile.pl

If you have any problems, comments, or bug reports, send them to: webmaster@eyeontoccoa.com.

Version History:
## 1.0 ##
- First Release

##1.1 ##
- Corrected a couple of errors in the BoardIndex.pl section.
- Choice of IP utility now available in Admin Center under BoardMod Mods -> Link IP (Reverse DNS, Whois, Geolocation, Traceroute).  Will add more if requested.
- Created exclusive language and admin files (link_ip.lng and link_ip.pl) for Admin Center functionality.

## 1.2 - Final ##
- Fixed a bug in Adminindex.pl that calls the link_ip.txt file.  Now checks for existence of file.
</mod info>

<author>
Brian Longo
</author>

<homepage>
http://www.eyeontoccoa.com/mods/
</homepage>

<edit file>
AdminIndex.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
$link_ip = "link_ip|Link IP Mod|Link IP Mod|";
push (@boardmod_mods, "$link_ip");
</add before>

<search for>
require "$vardir/Settings.pl";
require "$sourcedir/Subs.pl";
require "$sourcedir/System.pl";
require "$sourcedir/DateTime.pl";
require "$sourcedir/Load.pl";
require "$vardir/advsettings.txt";
require "$vardir/secsettings.txt";
require "$vardir/membergroups.txt";
</search for>

<add after>
if (-e("$vardir/link_ip.txt"))  {
	require "$vardir/link_ip.txt";  ## link IP mod
} 
</add after>

<edit file>
YaBB.pl
</edit file>

<search for>
$action = $INFO{'action'};
$SIG{__WARN__} = sub { &fatal_error("@_"); };
</search for>

<add before>
## start link IP mod - load link_ip.txt ##
if (-e("$vardir/link_ip.txt"))  {
    require "$vardir/link_ip.txt";
}
## end link IP mod ##

</add before>

<edit file>
Admin/Admin.pl
</edit file>

<search for>
		if ($newiplist[$i]->[0] =~ /\S+/ && $newiplist[$i]->[0] =~ /\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}/) {
			$guestiplist .= qq~$newiplist[$i]->[0]&nbsp;<span style="color: #FF0000;">(<i>$newiplist[$i]->[1]</i>)</span><br />~;
</search for>

<replace>
## start link IP mod - define $iplink ##
		if($iputil eq 0){$iputil = 'ptr';}
		if($iputil eq 1){$iputil = 'whois';}
		if($iputil eq 2){$iputil = 'city';}
		if($iputil eq 3){$iputil = 'tracert';}
   		$iplink = qq~<a href="http://www.dnsstuff.com/tools/$iputil.ch?ip=$newiplist[$i]->[0]" target="_blank" style="text-decoration: underline;">$newiplist[$i]->[0]</a>~;
## end link IP mod ##
	
		if ($newiplist[$i]->[0] =~ /\S+/ && $newiplist[$i]->[0] =~ /\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}/) {
			$guestiplist .= qq~$iplink&nbsp;<span style="color: #FF0000;">(<i>$newiplist[$i]->[1]</i>)</span><br />~;
</replace>

<edit file>
Admin/AdminSubList.pl
</edit file>

<search for>
'manageattachments',"Attachments.pl&Attachments",
'manageattachments2',"Attachments.pl&Attachments2",
</search for>

<add before>
'link_ip',"link_ip.pl&link_ip_set",  ## Link IP Mod ##
'link_ip2',"link_ip.pl&link_ip_set_2",  ## Link IP Mod ##
</add before>

<edit file>
Admin/ErrorLog.pl
</edit file>

<search for>
		if ($tmp_user eq "$useraccount{$tmp_user}") {
			if ($userprofile{$tmp_user}->[1]) {
				$username = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$tmp_user}" target ="_blank">$userprofile{$tmp_user}->[1]</a>~;
			} else {
				$username .= qq~$useraccount{$tmp_user}~;
			}
			$username .= qq~<br />($tmp_userip)~;
		} else {
			$username = qq~$tmp_user<br />($tmp_userip)~;
		}
</search for>

<replace>
## start link IP mod - define $iplink ##
     if($link_error eq 1){
		if($iputil eq 0){$iputil = 'ptr';}
		if($iputil eq 1){$iputil = 'whois';}
		if($iputil eq 2){$iputil = 'city';}
		if($iputil eq 3){$iputil = 'tracert';}
   		$iplink = qq~<a href="http://www.dnsstuff.com/tools/$iputil.ch?ip=$tmp_userip" target="_blank" style="text-decoration: underline;">$tmp_userip</a>~;		
     }
	 else{$iplink = $tmp_userip;}
## end link IP mod ##
		if ($tmp_user eq "$useraccount{$tmp_user}") {
			if ($userprofile{$tmp_user}->[1]) {
				$username = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$tmp_user}" target ="_blank">$userprofile{$tmp_user}->[1]</a>~;
			} else {
				$username .= qq~$useraccount{$tmp_user}~;
			}
			$username .= qq~<br />($iplink)~;
		} else {
			$username = qq~$tmp_user<br />($iplink)~;
		}
</replace>

<edit file>
Admin/link_ip.pl
</edit file>

<search for>
	if ($link_display) { $link_display_checked = ' checked '; }
</search for>

<add after>
	if ($link_ip_profile) { $link_ip_profile_checked = ' checked '; }
</add after>

<search for>
    	<div class="setting_cell">$linkip_txt{'14'}</div>
    	<div class="setting_cell2"><input type="checkbox" name="link_display" $link_display_checked /></div>
		<br />
</search for>

<add after>
    	<div class="setting_cell">$linkip_txt{'12'}</div>
    	<div class="setting_cell2"><input type="checkbox" name="link_ip_profile" $link_ip_profile_checked /></div>
		<br />
</add after>

<search for>
    $link_display = $FORM{'link_display'} ? 1 : 0;
</search for>

<add after>
	$link_ip_profile = $FORM{'link_ip_profile'} ? 1 : 0;
</add after>

<search for>
\$link_display = $link_display; #set to one to link the IP addresses in all posts
</search for>

<add after>
\$link_ip_profile = $link_ip_profile; # set to 1 to link IP address in user's profile to dnsstuff.com
</add after>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$link_ip_mod = "Link IP|Brian Longo|If you've ever wanted to see the details of a particular user's IP, this mod will link your users' IP with utilities from DNSstuff.com (Reverse DNS, Whois, Geolocation or Traceroute).|1.2|12/12/2005";
	push (@installed_mods, "$link_ip_mod");
</add before>

<edit file>
Admin/ViewMembers.pl
</edit file>

<search for>
		if ($userlastonline eq "") { $userlastonline = "-"; $tmpa = $days_reg; }
		else { $date1 = $userlastonline; &calcdifference; $userlastonline = $result; $tmpa = $userlastonline; }
		if ($userlastpost eq "") { $userlastpost = "-"; $tmpb = $days_reg; }
		else { $date1 = $userlastpost; &calcdifference; $userlastpost = $result; $tmpb = $userlastpost; }
		if ($userlastim eq "") { $userlastim = "-"; $tmpc = $days_reg; }
		else { $date1 = $userlastim; &calcdifference; $userlastim = $result; $tmpc = $userlastim; }
</search for>

<add before>
## start link IP mod ##
		if($iputil eq 0){$iputil = 'ptr';}
		if($iputil eq 1){$iputil = 'whois';}
		if($iputil eq 2){$iputil = 'city';}
		if($iputil eq 3){$iputil = 'tracert';}
		if(${$uid.$user}{'last_ip'} ne ""){$iplink = qq~<a href="http://www.dnsstuff.com/tools/$iputil.ch?ip=${$uid.$user}{'last_ip'}" target="_blank" style="text-decoration: underline;">${$uid.$user}{'last_ip'}&nbsp;</a>~;}
		else{$iplink = qq~${$uid.$user}{'last_ip'}~;}
## end link IP mod ##
</add before>

<search for>
		if ($iamadmin || ($iamgmod && $allow_gmod eq 1)){
		$yymain .= qq~<td class="windowbg2" width="4%" align="center">${$uid.$user}{'last_ip'}</td>~;}
		else {$yymain .= qq~<!-- Gmod access disabled -->~;} 
		$yymain .= qq~<td class="windowbg2" width="8%" align="center">$hidden</td></td>		
	</tr>~;
</search for>

<replace>
		if ($iamadmin || ($iamgmod && $allow_gmod eq 1)){
		$yymain .= qq~<td class="windowbg2" width="4%" align="center">$iplink</td>~;} ## link IP mod ##
		else {$yymain .= qq~<!-- Gmod access disabled -->~;} 
		$yymain .= qq~<td class="windowbg2" width="8%" align="center">$hidden</td></td>		
	</tr>~;
</replace>

<edit file>
Languages/English/last_ip.lng
</edit file>

<search for>
'11' => "Link IP addresses in member lists (general and admin)?",
</search for>

<add after>
'12' => "Link IP addresses in user profiles?",
</add after>

<edit file>
Sources/BoardIndex.pl
</edit file>

<search for>
	foreach $curentry (@entries) {
		chomp $curentry;
		($name, $value, $last_ip) = split(/\|/, $curentry);
		if (!$last_ip) { $last_ip = qq~</i></span><span class="error">$boardindex_txt{'no_ip'}</span><span class="small"><i>~; }
</search for>

<add after>
## start link IP mod - define $iplink ##
		if($iputil eq 0){$iputil = 'ptr';}
		if($iputil eq 1){$iputil = 'whois';}
		if($iputil eq 2){$iputil = 'city';}
		if($iputil eq 3){$iputil = 'tracert';}
   		$iplink = qq~<a href="http://www.dnsstuff.com/tools/$iputil.ch?ip=$last_ip" target="_blank" style="text-decoration: underline;">$last_ip</a>~;
## end link IP mod ##
</add after>

<search for>
				      $hidden .= qq~<i>$link{$name} ($last_ip)</i>~;
</search for>

<replace>
## start link IP mod ##
   		 	  	 	  if($link_ip_bi eq 1){$hidden .= qq~<i>$link{$name} ($iplink)</i>~;}
					  else {$hidden .= qq~<i>$link{$name} ($last_ip)</i>~;}
## end link IP mod ##
</replace>

<search for>
					$users .= qq~<i> ($last_ip)</i>~;
</search for>

<replace>
## start link IP mod ##
   		 	  	 	  if($link_ip_bi eq 1){$users .= qq~<i> ($iplink)</i>~;}
				      else {$users .= qq~<i> ($last_ip)</i>~;}
## end link IP mod ##
</replace>

<search for>
					$guestlist .= qq~<i>$last_ip</i>, ~;
</search for>

<replace>
## start link IP mod ##
				    if($link_ip_bi eq 1){$guestlist .= qq~<i>$iplink</i>, ~;}
					else {$guestlist .= qq~<i>$last_ip</i>, ~;}
## end link IP mod ##
</replace>

<edit file>
Sources/Display.pl
</edit file>

<search for>
		if ($iamadmin || $iamgmod && $gmod_access2{'ipban2'} eq "on") { $mip = $mip }
</search for>

<replace>
## start link IP mod - define $iplink ##
     if($link_display eq 1){
	    if($iputil eq 0){$iputil = 'ptr';}
	    if($iputil eq 1){$iputil = 'whois';}
	    if($iputil eq 2){$iputil = 'city';}
	    if($iputil eq 3){$iputil = 'tracert';}
   	    $iplink = qq~<a href="http://www.dnsstuff.com/tools/$iputil.ch?ip=$mip" target="_blank" style="text-decoration: underline;">$mip</a>~;
     }
	 else{$iplink=$mip;}
		if ($iamadmin || $iamgmod && $gmod_access2{'ipban2'} eq "on") { $mip = $iplink }
## end link IP mod ##
</replace>

<edit file>
Sources/Memberlist.pl
</edit file>

<search for>
<!-- #Start Last IP Mod part 4 - add Last IP data to member list ## -->
	 	~;
    if(($iamadmin && $show_ip eq 1) || ($iamgmod && $show_ip eq 1 && $allow_gmod eq 1)){
		$yymain .= qq~
		<td align="center" class="windowbg2">${$uid.$user}{'last_ip'}&nbsp;</td>
		~;
	}
	else {$yymain .= qq~<!-- Last IP Mod Off -->~;}
		$yymain .= qq~
<!-- ## End Last IP Mod part 4 ## -->
</search for>

<replace>
<!-- ## Start Last IP Mod part 4 - add Last IP data to member list and link IP ## -->
	 	~;
    if(($iamadmin && $show_ip eq 1) || ($iamgmod && $show_ip eq 1 && $allow_gmod eq 1)){
## start link IP mod ##
		if($iputil eq 0){$iputil = 'ptr';}
		if($iputil eq 1){$iputil = 'whois';}
		if($iputil eq 2){$iputil = 'city';}
		if($iputil eq 3){$iputil = 'tracert';}
		if(${$uid.$user}{'last_ip'} ne ""){$iplink = qq~<a href="http://www.dnsstuff.com/tools/$iputil.ch?ip=${$uid.$user}{'last_ip'}" target="_blank" style="text-decoration: underline;">${$uid.$user}{'last_ip'}&nbsp;</a>~;}
		else{$iplink = qq~${$uid.$user}{'last_ip'}~;}
## end link IP mod ##
		$yymain .= qq~
		<td align="center" class="windowbg2">$iplink</td>
		~;
	}
	else {$yymain .= qq~<!-- Last IP Mod Off -->~;}
		$yymain .= qq~
<!-- ## End Last IP Mod part 4 ## -->
</replace>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
## Start Last IP Mod - add user's last IP to profile ##
		if($show_profile_ip eq 1 && ($iamadmin && $show_ip eq 1) || ($iamgmod && $show_ip eq 1 && $allow_gmod eq 1)){
	       $userlastip=${$uid.$user}{'last_ip'};
		   LoadLanguage("last_ip");
		   $yymain .= qq~
		   <div style="float: left; width: 30%; padding-top: 5px;  padding-bottom: 5px;">
		   <b>$ip_txt{'1'}: </b>
		   </div>
		   <div style="float: left; width: 70%; padding-top: 5px;  padding-bottom: 5px;">
		   $userlastip
		   </div>~;
		}
		$yymain .= qq~
<!--## End Last IP Mod ##-->
</search for>

<replace>
## Start Last IP Mod - add user's last IP to profile ##
		if($show_profile_ip eq 1 && ($iamadmin && $show_ip eq 1) || ($iamgmod && $show_ip eq 1 && $allow_gmod eq 1)){
	       $userlastip=${$uid.$user}{'last_ip'};
		   LoadLanguage("last_ip");
## start link IP mod - define $iplink ##
           if($link_ip_profile eq 1){
		      if($iputil eq 0){$iputil = 'ptr';}
		      if($iputil eq 1){$iputil = 'whois';}
		      if($iputil eq 2){$iputil = 'city';}
		      if($iputil eq 3){$iputil = 'tracert';}
   		      $iplink = qq~<a href="http://www.dnsstuff.com/tools/$iputil.ch?ip=$userlastip" target="_blank" style="text-decoration: underline;">$userlastip</a>~;
           }
		   else {$iplink=$userlastip;}
## end link IP mod ##
		   $yymain .= qq~
		   <div style="float: left; width: 30%; padding-top: 5px;  padding-bottom: 5px;">
		   <b>$ip_txt{'1'}: </b>
		   </div>
		   <div style="float: left; width: 70%; padding-top: 5px;  padding-bottom: 5px;">
		   $iplink
		   </div>~;
		}
		$yymain .= qq~
<!--## End Last IP Mod ##-->
</replace>

<edit file>
Variables/link_ip.txt
</edit file>

<search for>
$link_display = 1; #set to one to link the IP addresses in all posts
</search for>

<add after>
$link_ip_profile = 1; # set to 1 to link IP address in user's profile to dnsstuff.com
</add after>