<id>
Link IP for Users Today Mod
</id>

<version>
1.2
</version>

<mod info>
Tested on and coded for YaBB 2.x

This patch will allow you to run the Link IP mod with the Users Today mod mod.  Turns the IP addresses in the Users Today Mod's Guest IP Log from regular text to links.  Also, if you've turned on the option to show guests' IP addresses on the board Index, this mod will turn those IP addresses into links.

You must also install one of the following mods to be able to run the IP utility selection in Admin Center:

- Link IP
- Link IP for Hidden User mod
- Link IP for Last IP mod
- Link IP for Hidden User and Last IP mod

**Please read the "readme.txt" file for more extensive information.**

If you're interested in knowing the details of the IP addresses of your users, this mod will turn your IP addresses in your Board Index and Message Display from regular text into links that will connect with DNSstuff.com's IP utilities (Reverse DNS, Whois, Geolocation, Traceroute).

Installation Instructions:

1) Run this mod.
2) Upload your modified files to your server (note below) as well as the link_ip.lng (English only for now) and link_ip.pl (to Admin directory).
3) Go into the Link IP configuration area in the Admin Center to select which IP utility you want to use.

Modifies the following files:
-Admin/users_today.pl
-Sources/users_today_2.pl

If you have any problems, comments, or bug reports, send them to: webmaster@eyeontoccoa.com.

Version History:
## 1.1 ##
- First Release

## 1.2 ##
- Final
</mod info>

<author>
Brian Longo
</author>

<homepage>
http://www.eyeontoccoa.com/mods
</homepage>

<edit file>
Admin/users_today.pl
</edit file>

<search for>
   if (-e ("$vardir/guesttoday.txt")) {
      open(GUESTFILE,"$vardir/guesttoday.txt");
	  @gtoday=<GUESTFILE>;
	  close(GUESTFILE);
	  $yymain .= qq~
		   <div class="windowbg2" style="width: 100%; overflow: auto; height: 200px; padding: 2px 0px 2px 2px; margin: -1px 0px -1px -1px;">~;
	    $guesttodaycount = @gtoday;
	    for($g=1;$g < $guesttodaycount;$g++){
	       $gtoday[$g] =~ s/\n//gi;
	       $g_ip = $gtoday[$g];
	       $yymain .= qq~
	       <span style="padding: 0px 5px; font-size: 12px;">$g_ip</span><br />~;
		}
</search for>

<replace>
## start link IP mod - define $iplink ##
		if($iputil eq 0){$iputil = 'ptr';}
		if($iputil eq 1){$iputil = 'whois';}
		if($iputil eq 2){$iputil = 'city';}
		if($iputil eq 3){$iputil = 'tracert';}
## end link IP mod ##
   if (-e ("$vardir/guesttoday.txt")) {
      open(GUESTFILE,"$vardir/guesttoday.txt");
	  @gtoday=<GUESTFILE>;
	  close(GUESTFILE);
	  $yymain .= qq~
		   <div class="windowbg2" style="width: 100%; overflow: auto; height: 200px; padding: 2px 0px 2px 2px; margin: -1px 0px -1px -1px;">~;
	    $guesttodaycount = @gtoday;
	    for($g=1;$g < $guesttodaycount;$g++){
	       $gtoday[$g] =~ s/\n//gi;
	       $g_ip = $gtoday[$g];
		   $iplink = qq~<a href="http://www.dnsstuff.com/tools/$iputil.ch?ip=$g_ip" target="_blank" style="text-decoration: underline;">$g_ip</a>~; ## Link IP for Users Today ##
	       $yymain .= qq~
	       <span style="padding: 0px 5px; font-size: 12px;">$iplink</span><br />~; ## $iplink inserted for Link IP Mod ##
		}
</replace>

<edit file>
Sources/users_today_2.pl
</edit file>

<search for>
## Reading the guests today file ##
    open(GUESTFILE,"$vardir/guesttoday.txt");
	@gtoday=<GUESTFILE>;
	close(GUESTFILE);
	$guesttodaycount = @gtoday;
	for($g=1;$g < $guesttodaycount;$g++){
	   $gtoday[$g] =~ s/\n//gi;
	   $g_ip = $gtoday[$g];
       if($g_ip eq $user_ip){$gInserted = 'true';}
	   if($view_ips eq 1 && ($iamadmin || $iamgmod)){
	      $guesttoday .= qq~$g_ip~;
		  if($guesttodaycount > 1) {$guesttoday .= qq~, ~;}
	   }
	   else {$guesttoday = qq~<!--Not listing IP addresses-->~;}
	}
</search for>

<replace>
## Reading the guests today file ##
## start link IP mod - define $iplink ##
    if($iputil eq 0){$iputil = 'ptr';}
	if($iputil eq 1){$iputil = 'whois';}
	if($iputil eq 2){$iputil = 'city';}
	if($iputil eq 3){$iputil = 'tracert';}
## end link IP mod ##
    open(GUESTFILE,"$vardir/guesttoday.txt");
	@gtoday=<GUESTFILE>;
	close(GUESTFILE);
	$guesttodaycount = @gtoday;
	for($g=1;$g < $guesttodaycount;$g++){
	   $gtoday[$g] =~ s/\n//gi;
	   $g_ip = $gtoday[$g];
       if($g_ip eq $user_ip){$gInserted = 'true';}
   	   $iplink = qq~<a href="http://www.dnsstuff.com/tools/$iputil.ch?ip=$g_ip" target="_blank" style="text-decoration: underline;">$g_ip</a>~; ## Link IP for Users Today ##
	   if($view_ips eq 1 && ($iamadmin || $iamgmod)){
	      $guesttoday .= qq~$iplink~;
		  if($guesttodaycount > 1) {$guesttoday .= qq~, ~;}
	   }
	   else {$guesttoday = qq~<!--Not listing IP addresses-->~;}
	}
</replace>